package cn.iocoder.yudao.module.pms.service.iotmodeltemplate;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.iotmodeltemplate.vo.IotModelTemplatePageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.iotmodeltemplate.vo.IotModelTemplateSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotmodeltemplate.IotModelTemplateDO;
import cn.iocoder.yudao.module.pms.dal.mysql.iotmodeltemplate.IotModelTemplateMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import java.util.Collection;
import java.util.List;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.pms.enums.ErrorCodeConstant.IOT_DEVICE_TEMPLATE_NOT_EXISTS;

/**
 * PMS 功能优化 设备模板 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class IotModelTemplateServiceImpl implements IotModelTemplateService {

    @Resource
    private IotModelTemplateMapper iotModelTemplateMapper;

    @Override
    public Long createIotDeviceTemplate(IotModelTemplateSaveReqVO createReqVO) {
        // 插入
        IotModelTemplateDO iotModelTemplate = BeanUtils.toBean(createReqVO, IotModelTemplateDO.class);
        iotModelTemplateMapper.insert(iotModelTemplate);
        // 返回
        return iotModelTemplate.getId();
    }

    @Override
    public void updateIotDeviceTemplate(IotModelTemplateSaveReqVO updateReqVO) {
        // 校验存在
        validateIotDeviceTemplateExists(updateReqVO.getId());
        // 更新
        IotModelTemplateDO updateObj = BeanUtils.toBean(updateReqVO, IotModelTemplateDO.class);
        iotModelTemplateMapper.updateById(updateObj);
    }

    @Override
    public void deleteIotDeviceTemplate(Long id) {
        // 校验存在
        validateIotDeviceTemplateExists(id);
        // 删除
        iotModelTemplateMapper.deleteById(id);
    }

    private void validateIotDeviceTemplateExists(Long id) {
        if (iotModelTemplateMapper.selectById(id) == null) {
            throw exception(IOT_DEVICE_TEMPLATE_NOT_EXISTS);
        }
    }

    @Override
    public IotModelTemplateDO getIotDeviceTemplate(Long id) {
        return iotModelTemplateMapper.selectById(id);
    }

    @Override
    public PageResult<IotModelTemplateDO> getIotDeviceTemplatePage(IotModelTemplatePageReqVO pageReqVO, Collection<Long> deptIds) {
        return iotModelTemplateMapper.selectPage(pageReqVO,deptIds);
    }

    @Override
    public IotModelTemplateDO getTemplateByDeviceCategoryId(Long deviceCategoryId) {
        return iotModelTemplateMapper.selectByDeviceCategoryId(deviceCategoryId);
    }

    @Override
    public void updateDeviceTemplateStatus(Long id, Integer status) {
        // 校验 设备属性模板 存在
        validateIotDeviceTemplateExists(id);
        // 更新状态
        IotModelTemplateDO updateObj = new IotModelTemplateDO();
        updateObj.setId(id);
        updateObj.setStatus(status);
        iotModelTemplateMapper.updateById(updateObj);
    }

    @Override
    public List<IotModelTemplateDO> modelList() {
        return iotModelTemplateMapper.modelList();
    }

    @Override
    public List<IotModelTemplateDO> isRelated(IotModelTemplatePageReqVO reqVO) {
        return iotModelTemplateMapper.isRelated(reqVO);
    }

}